#ifdef __APPLE__

#include "seaview.h"
#include <FL/filename.H>
#include <Carbon/Carbon.h>

/* included functions */
char *mac_GetOutputFName_Plus(const char *dfault, const char *message, int);

// needed functions
extern "C" {  
	void PtoC(const void *in, void *out);
	void CtoP(const void *in, void *out);
	}

extern int printout_block, printout_fontsize;
extern int printout_vary, printout_black;
extern paperformat printout_pageformat;


static pascal void MyNavEventProc_Plus (NavEventCallbackMessage callBackSelector,
                                   NavCBRecPtr callBackParms,
                                   NavCallBackUserData callBackUD)
{
OSErr err;
static Handle gDitlList = NULL;
static DialogItemIndex index;
static DialogRef ref;
static ControlRef var_control = NULL;
Rect rect; Handle h; DialogItemType dtype; Str255 text; ControlRef control;
char text2[256];

if(callBackSelector == kNavCBCustomize) {
	if(callBackParms->customRect.bottom == 0) 
			callBackParms->customRect.bottom = callBackParms->customRect.top + 58;
	if(callBackParms->customRect.right == 0) 
			callBackParms->customRect.right = callBackParms->customRect.left + 425;
	}
else if(callBackSelector == kNavCBStart) {
	gDitlList = GetResource ('DITL', 128);
	if(gDitlList != NULL) err = NavCustomControl(callBackParms->context, 
                            kNavCtlAddControlList, gDitlList);
    err = NavCustomControl(callBackParms->context, kNavCtlGetFirstControlID, &index);
    index++;
    ref = GetDialogFromWindow(callBackParms->window);
	sprintf(text2,"%2d", printout_block);
	CtoP(text2, text);
	GetDialogItem(ref, index + 1, &dtype, &h, &rect);
	SetDialogItemText(h, text);
	sprintf(text2,"%2d", printout_fontsize);
	CtoP(text2, text);
	GetDialogItem(ref, index + 3, &dtype, &h, &rect);
	SetDialogItemText(h, text);
	if(printout_black == PDF_COLOR) {
		err = GetDialogItemAsControl(ref, index + 4, &control);
		if(err == 0) SetControl32BitValue(control, 1);
		}
	else if(printout_black == PDF_BW) {
		err = GetDialogItemAsControl(ref, index + 8, &control);
		if(err == 0) SetControl32BitValue(control, 1);
		}
	else if(printout_black == TEXT_ONLY) {
		err = GetDialogItemAsControl(ref, index + 9, &control);
		if(err == 0) SetControl32BitValue(control, 1);
		}
	
	err = GetDialogItemAsControl(ref, index + 5, &control);
	if(err == 0) SetControl32BitValue(control, printout_pageformat == 0);
	err = GetDialogItemAsControl(ref, index + 6, &control);
	if(err == 0) SetControl32BitValue(control, printout_pageformat == 1);

	err = GetDialogItemAsControl(ref, index + 7, &var_control);
	if(err == 0) SetControl32BitValue(var_control, printout_vary);
	if(*(int *)callBackUD) ActivateControl(var_control);
	else DeactivateControl(var_control);
	}
else if(callBackSelector == kNavCBTerminate) {
	if(gDitlList != NULL) {
		GetDialogItem(ref, index + 1, &dtype, &h, &rect);
		GetDialogItemText(h, text);
		PtoC(text, text2);
		sscanf(text2,"%d", &printout_block);
		GetDialogItem(ref, index + 3, &dtype, &h, &rect);
		GetDialogItemText(h, text);
		PtoC(text, text2);
		sscanf(text2,"%d", &printout_fontsize);
		ReleaseResource( gDitlList );
		}
	var_control = NULL;
	}
else if(callBackSelector == kNavCBEvent ) {
	if(var_control != NULL && callBackParms->eventData.itemHit == index + 7) {
		printout_vary = (printout_vary + 1) % 2;
		SetControl32BitValue(var_control, printout_vary);
		}
	else if(callBackParms->eventData.itemHit == index + 4) {
		if(printout_black != PDF_COLOR) {
			printout_black = PDF_COLOR;
			GetDialogItemAsControl(ref, index + 4, &control);
			SetControl32BitValue(control, 1);
			GetDialogItemAsControl(ref, index + 8, &control);
			SetControl32BitValue(control, 0);
			GetDialogItemAsControl(ref, index + 9, &control);
			SetControl32BitValue(control, 0);
			}
		}
	else if(callBackParms->eventData.itemHit == index + 8) {
		if(printout_black != PDF_BW) {
			printout_black = PDF_BW;
			GetDialogItemAsControl(ref, index + 4, &control);
			SetControl32BitValue(control, 0);
			GetDialogItemAsControl(ref, index + 8, &control);
			SetControl32BitValue(control, 1);
			GetDialogItemAsControl(ref, index + 9, &control);
			SetControl32BitValue(control, 0);
			}
		}
	else if(callBackParms->eventData.itemHit == index + 9) {
		if(printout_black != TEXT_ONLY) {
			printout_black = TEXT_ONLY;
			GetDialogItemAsControl(ref, index + 4, &control);
			SetControl32BitValue(control, 0);
			GetDialogItemAsControl(ref, index + 8, &control);
			SetControl32BitValue(control, 0);
			GetDialogItemAsControl(ref, index + 9, &control);
			SetControl32BitValue(control, 1);
			}
		}
	else if(callBackParms->eventData.itemHit == index + 5) {
		if(printout_pageformat == LETTER) {
				GetDialogItemAsControl(ref, index + 5, &control);
				SetControl32BitValue(control, 1);
				GetDialogItemAsControl(ref, index + 6, &control);
				SetControl32BitValue(control, 0);
				printout_pageformat = A4;
				}
		}
	else if(callBackParms->eventData.itemHit == index + 6) {
		if(printout_pageformat == A4) {
				GetDialogItemAsControl(ref, index + 6, &control);
				SetControl32BitValue(control, 1);
				GetDialogItemAsControl(ref, index + 5, &control);
				SetControl32BitValue(control, 0);
				printout_pageformat = LETTER;
				}
		}
	}
return;
}


char *mac_GetOutputFName_Plus(const char *dfault, const char *message, int use_only_button)
{
    OSErr               anErr = noErr;
    NavReplyRecord      reply;
    NavDialogRef        navDialog;
    NavDialogCreationOptions    dialogOptions;
    OSType              fileTypeToSave = 'TEXT';
    OSType              creatorType;
    NavEventUPP         eventProc = NewNavEventUPP (MyNavEventProc_Plus);
	char *rsult = NULL;
	static int *p_use;
    Boolean ok;
	static char pathname[FL_PATH_MAX];

    anErr = NavGetDefaultDialogCreationOptions (&dialogOptions);
	if(anErr != noErr) return FALSE;
    dialogOptions.windowTitle = CFStringCreateWithCString(NULL, message, kCFStringEncodingMacRoman);
    dialogOptions.optionFlags |= kNavNoTypePopup;
    dialogOptions.optionFlags &= ~ kNavAllowStationery;
    dialogOptions.saveFileName = CFStringCreateWithCString(NULL, dfault, kCFStringEncodingUTF8); 

	creatorType = kNavGenericSignature;
	p_use = &use_only_button;
  anErr = NavCreatePutFileDialog( &dialogOptions, fileTypeToSave, creatorType, eventProc, p_use, &navDialog );
  CFRelease(dialogOptions.saveFileName);
  if(anErr != noErr) return NULL;
  
  anErr = NavDialogRun( navDialog );
  if(anErr != noErr) return NULL;
  
  anErr = NavDialogGetReply( navDialog, &reply );
  
 if (anErr == noErr && reply.validRecord) {
				FSRef fileRef;
				CFURLRef directoryURL, fileURL;
				
				anErr = AEGetNthPtr( &reply.selection, 1, typeFSRef, NULL, NULL, &fileRef, sizeof( FSRef ), NULL );
                if (anErr == noErr)
                {
						directoryURL = CFURLCreateFromFSRef( kCFAllocatorDefault, &fileRef );
                        // append new filename to this path
						fileURL = CFURLCreateCopyAppendingPathComponent( kCFAllocatorDefault, directoryURL, reply.saveFileName, false );
						ok = CFURLGetFileSystemRepresentation(fileURL, true, (UInt8 *)pathname, FL_PATH_MAX);
						CFRelease(fileURL); CFRelease(directoryURL);
                        if(ok) rsult = pathname;
                }
	}
  DisposeNavEventUPP(eventProc);
  NavDisposeReply( &reply );
  NavDialogDispose( navDialog );
return rsult;
}

#endif
